from webpicdownloader.controller.Frames import Frames
from webpicdownloader.controller.MainController import MainController


class InfoController:
    """
        Controller - InfoController

    This controller manages the display of information in the information view.

    @author     Jérémi Nihart / EndMove
    @link       https://git.endmove.eu/EndMove/WebPicDownloader
    @version    1.0.0
    @since      2022-08-30
    """
    # Variables
    __main_controller: MainController = None
    __view = None

    # Constructor
    def __init__(self, controller: MainController) -> None:
        """
            Constructor

        * :controller: -> The main application cpntroller.
        """
        # Setup variables
        self.__main_controller = controller

    # START View methods
    def set_view(self, view) -> None:
        """
            [function for view]
            
        :view: -> The view that this controller manage.
        """
        self.__view = view
        self.__view.set_title(self.__main_controller.get_config('about_title'))
        self.__view.set_content(self.__main_controller.get_config('about_content'))
        self.__view.set_version(
            f"version: {self.__main_controller.get_config('app_version')} - {self.__main_controller.get_config('app_version_date')}"
        )
    # END View method

    # START View events
    def on_change_view(self, frame: Frames) -> None:
        """
            [event function for view]
        => Call this event method when the user requests to change the window.

        * :frame: -> The frame we want to launch.
        """
        self.__main_controller.change_frame(frame)
    # END View events
